// fapiaoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "fapiao.h"
#include "fapiaoDlg.h"
#include "Preview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFapiaoDlg dialog

CFapiaoDlg::CFapiaoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFapiaoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFapiaoDlg)
	m_khmc = _T("");
	m_zph = _T("");
	m_bh = _T("");
	m_spmc = _T("");
	m_gg = _T("");
	m_dw = _T("");
	m_sl = 0;
	m_kpdw = _T("");
	m_kpr = _T("");
	m_date = COleDateTime::GetCurrentTime();
	m_dj = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFapiaoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFapiaoDlg)
	DDX_Text(pDX, IDC_EDIT1, m_khmc);
	DDX_Text(pDX, IDC_EDIT2, m_zph);
	DDX_Text(pDX, IDC_EDIT3, m_bh);
	DDX_Text(pDX, IDC_EDIT4, m_spmc);
	DDX_Text(pDX, IDC_EDIT5, m_gg);
	DDX_Text(pDX, IDC_EDIT6, m_dw);
	DDX_Text(pDX, IDC_EDIT7, m_sl);
	DDX_Text(pDX, IDC_EDIT9, m_kpdw);
	DDX_Text(pDX, IDC_EDIT10, m_kpr);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER1, m_date);
	DDX_Text(pDX, IDC_EDIT8, m_dj);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFapiaoDlg, CDialog)
	//{{AFX_MSG_MAP(CFapiaoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTPREVIEW, OnButpreview)
	ON_BN_CLICKED(IDC_BUTOK, OnButok)
	ON_BN_CLICKED(IDC_BUTPRINT, OnButprint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFapiaoDlg message handlers

BOOL CFapiaoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	CPreview dlg;
	// TODO: Add extra initialization here
	num = 1;
	sum = 0;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFapiaoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFapiaoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFapiaoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFapiaoDlg::OnButpreview() 
{
	// TODO: Add your control notification handler code here
	dlg.DoModal();
}

void CFapiaoDlg::OnButok() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if(num > 3)
	{
		MessageBox("商品不能超过3种！");
		return;
	}
	if(m_khmc.IsEmpty() | m_zph.IsEmpty() | m_bh.IsEmpty() | m_spmc.IsEmpty() 
		| m_gg.IsEmpty() | m_dw.IsEmpty() | m_kpdw.IsEmpty() | m_kpr.IsEmpty())
	{
		MessageBox("基本信息不能为空！");
		return;
	}
	if(m_sl == 0 | m_dj == 0)
	{
		MessageBox("数据不能为零！");
		return;
	}
	CString sl,dj,y,m,d,str,strsum;
	sl.Format("%d",m_sl);
	dj.Format("%f",m_dj);
	int n;
	n = strcspn(dj,".");
	dj = dj.Left(n+3);
	dlg.sarrays[num][0] = m_bh;
	dlg.sarrays[num][1] = m_spmc;
	dlg.sarrays[num][2] = m_gg;
	dlg.sarrays[num][3] = m_dw;
	dlg.sarrays[num][4] = sl;
	dlg.sarrays[num][5] = dj;
	dlg.khmc = m_khmc;
	dlg.zph = m_zph;
	dlg.kpdw = m_kpdw;
	dlg.kpr = m_kpr;
	//获得时间控件的日期
	int year,month,day,nm;
	year = m_date.GetYear();
	month = m_date.GetMonth();
	day = m_date.GetDay();
	y.Format("%d",year);
	m.Format("%d",month);
	d.Format("%d",day);
	dlg.darrays[0] = y;
	dlg.darrays[1] = m;
	dlg.darrays[2] = d;
	str.Format("%f",m_sl*m_dj);
	nm = strcspn(str,".");
	dlg.harrays[num-1] = str.Left(nm+3);
	sum += (m_sl*m_dj);
	strsum.Format("%f",sum);
	nm = strcspn(strsum,".");
	dlg.harrays[3] = strsum.Left(nm+3);
	dlg.hanshu();
	//将只须填写一便的信息设置为不可用
	GetDlgItem(IDC_EDIT1)->EnableWindow(false);
	GetDlgItem(IDC_EDIT2)->EnableWindow(false);
	GetDlgItem(IDC_EDIT9)->EnableWindow(false);
	GetDlgItem(IDC_EDIT10)->EnableWindow(false);
	GetDlgItem(IDC_DATETIMEPICKER1)->EnableWindow(false);
	num++;
}

void CFapiaoDlg::OnButprint() 
{
	// TODO: Add your control notification handler code here
	CPrintDialog m_printdlg(false);
	if (m_printdlg.DoModal()==IDOK)
	{
		CDC dc1;		
		dc1.Attach(m_printdlg.GetPrinterDC());			
		int leftmargin;
		leftmargin = dc1.GetDeviceCaps(PHYSICALOFFSETX);
		CRect m_rect(-leftmargin,0,dc1.GetDeviceCaps(PHYSICALWIDTH)-leftmargin,dc1.GetDeviceCaps(PHYSICALHEIGHT)) ;		
		dlg.DrawReport(m_rect,&dc1,true);
	}
}
